function LabC=LabC(n)
  // reçoit un entier n
  // retourne une matrice nxn 
  //correspondant au labyrinthe construit graphiquement
  // convention case noire = mur case bleue=vide
  //un clic de souris pour changer la couleur d'une case
  // penser à positionner l'entree et la sortie
  //
  //Pour sortir : un clic à l'extérieur du labyrinthe
  //
    

plot2d([0,n],[0,n],[-1,-1],"022");

//dessin de la matrice vide
for i=0:n-1 do,for j=0:n do, xrects([i; j ;1 ;1],[2]), 
   end;
end;

//dessin de la grille
for i=0:n do, xsegs([i;i],[0;n]), end;

for i=0:n do, xsegs([0;n],[i;i]), end;

//construction d'un labyrinthe stocké dans la matrice M
M=zeros(n,n);
for i=0:n-1 do, M(i+1,10)=1
  xrects([i; 10 ;1 ;1],[1])
  end
  for i=0:n-1 do, M(i+1,1)=1
    xrects([i; 1 ;1 ;1],[1])
  end
  for i=1:n do, M(1,i)=1 
    xrects([0; i ;1 ;1],[1])
  end
  for i=1:n do, M(10,i)=1
    xrects([9;i; ;1 ;1],[1])
end
  
xc=0;
  [b,xc,yc]=xclick();
while (xc<n)&(xc>=0)&(yc<n)&(yc>=0) do, 
  xc=floor(xc);
  yc=floor(yc);
  M(xc+1,yc+1)=1-M(xc+1,yc+1);
  xrects([xc; yc+1 ;1 ;1],[2-M(xc+1,yc+1)])
    [b,xc,yc]=xclick();
  end
LabC=1-M

endfunction

//affichage d'un labyrinthe stocké dans une 
//matrice M de taille nxn

function LabA=LabA(M,n)
  Mtmp=1-M
  plot2d([0,n],[0,n],[-1,-1],"022");
for i=0:n-1 do,for j=0:n-1 do, xrects([i; j+1 ;1 ;1],[Mtmp(i+1,j+1)]), 
   end;
 end;
endfunction


function depl=dedale(fi,fj,di,dj)
  // fonction booleene qui retourne la  valeur si vraie 
  // la sortie est trouvée à partir de la position initial di,dj
  // en passant par la position fi,fj
  // travaille sur un labyrinthe stocke dans une matrice L
  // par convention L(i,j)=0 pour un mur
  //                       1 espace vide
   // L est utilisee en variable globale
  // si sj designent la la position de la sortie sur la matrice
  xrects([fi-1;fj;1;1],[3]);
  if [fi,fj]=[si,sj] then sortie=%t
  else sortie=%f
  end
  if ~sortie & fi+1<>di & L(fi+1,fj)>0 then
    sortie=dedale(fi+1,fj,fi,fj)
  end
  if ~sortie & fi-1<>di & L(fi-1,fj)>0 then
    sortie=dedale(fi-1,fj,fi,fj)
  end
  if ~sortie & fj+1<>dj & L(fi,fj+1)>0 then
    sortie=dedale(fi,fj+1,fi,fj)
  end
  if ~sortie & fj-1<>dj & L(fi,fj-1)>0 then
    sortie=dedale(fi,fj-1,fi,fj)
  end
  if ~sortie then  xrects([fi-1;fj;1;1],[2]);
  end
  depl=sortie
endfunction

  